



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>c++中的流</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">c++中的流</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-03 03:15:46 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1300168/201901/1300168-20190105182613357-1318250776.jpg" /></p>
<p><strong>streambuf类</strong>为缓冲区提供内存，并提供了用于填充缓冲区，访问缓冲区，刷新新缓冲区和管理缓冲区内存的类方法。</p>
<p><strong>ios_base类</strong>表示流的一般特征，如是否可读，是二进制还是文本流等。</p>
<p><strong>ios类</strong>基于ios_base，其中包括了一个之指向streambuf对象的的指针成员。</p>
<h3>缓冲区介绍</h3>
<p><strong>输入：</strong>从磁盘上读取大量信息，将这些信息存储在缓冲区中，然后每次从缓冲区读取一个字节，到达缓冲区尾部，在从磁盘上读取另一块数据。</p>
<p>　　　<strong>但是键盘每次输入一个字符时可以用不缓冲区</strong>，但是用缓冲区输入可以让程序没有传给程序之前返回并改正，c++通常是用户按下回车键刷新缓冲区，</p>
<p><strong>输出：</strong>程序首先填满缓冲区，然后把整块数据给磁盘，并清空缓冲区，已备下一批输入。</p>
<p>　　　<strong>对于输出屏幕</strong>，输出换行符时刷新缓冲区（也可能是其他：当输入语句到达时，他刷新缓冲区中当前所有输出）</p>
<p><strong>刷新缓冲：</strong>用cout将字节发送给标准输出时由于ostram类对cout对象输出进行缓冲，输出并不会直接发送到目标地址，而是在缓冲区中，直到缓冲区填满，然后flush缓冲区，把内容发送出去并且清空缓冲，缓冲区通常为512byte或其整数倍。</p>
<p>　　对于<strong>屏幕</strong>来说，程序不必等到缓冲区填满，<strong>1.</strong>将换行符发送到缓冲区时刷新缓冲区；<strong>2.</strong>输入即将发生时刷新缓冲区。</p>
<p>　　由于程序运行时并不总是知道外部输入的进度，很难控制是不是全部清除输入缓冲区的内容。通常我们有可能只是希望放弃输入缓冲区中的一部分，而不是全部。比如清除掉当前行、或者清除掉行尾的换行符等等。但要是缓冲区中已经有了下一行的内容，这部分可能是我们想保留的。这个时候最好不要用sync()。可以考虑用ignore函数代替</p>
<div>
<pre class="prettyprint linenums">cin.ignore(numeric_limits&lt;std::streamsize&gt;::max(),'/n');//清除当前行<br />
cin.ignore(numeric_limits&lt;std::streamsize&gt;::max());     //清除cin里所有内容</pre>
</div>
<p>numeric_limits&lt;std::streamsize&gt;::max()不过是climits头文件定义的流使用的最大值，你也可以用一个足够大的整数代替它。使用ignore显然能比sync()更精确控制缓冲区</p>
<p>cin.ignore(1024,'\n')，通常把第一个参数设置得足够大，这样实际上总是只有第二个参数'\n'起作用，所以这一句就是把回车（包括回车）之前的所以字符从输入缓冲（流）中清除出去。</p>
<div>
<pre class="prettyprint linenums">flush(cout);<br />
cout&lt;&lt;"hello word"&lt;&lt;flush;<br />
cout&lt;&lt;"hello word"&lt;&lt;endl;//刷新缓冲区并插入换行符 </pre>
</div>
<p>以上三种方式均可以刷新缓冲区</p>
<p>但cout&lt;&lt;'\n';只是输出换行符，不刷新缓冲区；\n只代表换行的转义字符;\n是C中间的格式输出换行,C＋＋保留了下来;输出'\n'是实际输出了的'\10'，往输出流里添加了信息，所有的字符都是'\xx'的形式，换行符也是，你用其它任何字符输出一下，前面都会有四个'*'填充的</p>
<p>程序员常常在调试时添加打印语句。这类语句应该保证&lsquo;一直&rsquo;刷新流。否则，如果程序崩溃，输出可能还停留在缓冲区中，从而导致关于程序崩溃位置的错误推断</p>
<p>缓冲区的操作<a href="https://liam.page/2017/12/31/buffer-of-stream-in-Cpp/" rel="external nofollow noreferrer">https://liam.page/2017/12/31/buffer-of-stream-in-Cpp/</a>&nbsp; &nbsp;<a href="https://izualzhy.cn/stream-buffer" rel="external nofollow noreferrer">https://izualzhy.cn/stream-buffer</a></p>
<div>
<pre class="prettyprint linenums">#include &lt;iostream&gt;<br />
#include &lt;sstream&gt;<br />
#include &lt;cstdio&gt;<br />
using namespace std;

int main()<br />
{<br />
    stringstream ss;<br />
    streambuf *buf=cout.rdbuf();<br />
    //使用了新的缓冲区后，字符串不会输出到屏幕，而是由stringstream管理<br />
    cout.rdbuf(ss.rdbuf());<br />
    cout&lt;&lt;"hello word"&lt;&lt;endl;

    printf("%s",ss.str().c_str());

    cout.rdbuf(buf);<br />
    cout&lt;&lt;"hello word"&lt;&lt;endl;<br />
    return ;<br />
}</pre>
</div>
<h3>基于控制台</h3>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1300168/201901/1300168-20190104153617792-1416429390.jpg" /></p>
<p><strong>继承关系</strong></p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1300168/201901/1300168-20190104154320045-1309501580.png" /></p>
<p><strong>c++将输出看做字节流，将数值类型转换为文本形式表示的字符流（将数据内部表示（二进制形式）转换为字符字节组成的输出流）</strong></p>
<p><strong>cout：</strong>对于void*类型，打印其地址数值（<strong>一端关联显示器另一端关联程序</strong>）</p>
<p><strong>cin：</strong>从非空白字符开始，到与目标类型不匹配的第一个字符之间的全部内容（<strong>一端关联键盘另一端关联程序</strong>）</p>
<p><strong>cerr：</strong>关联输出设备（通常为显示器）没有缓冲区，信息直接输出到屏幕，不会等到新的换行或缓冲区满</p>
<p><strong>clog：</strong>关联输出设备（通常为显示器）有缓冲区</p>
<p><strong>ostream：</strong>ostream &amp;&lt;&lt;使用该操作符返回一个指向该对象的引用，插入操作符的<strong>返回值是调用该操作符的对象</strong></p>
<div>
<pre class="prettyprint linenums">        int a=,sum=;<br />
    while(cin&gt;&gt;a)<br />
        sum+=a;<br />
    //输入1 2 3 4 5 6c 60     </pre>
</div>
<p>由于输入缓冲，在用户键入回车之前不会发送给程序，但是循环在了对字符c出停止了处理，导致cin&gt;&gt;a返回alse，终止循环</p>
<p><strong>状态流</strong></p>
<p>　　cin或cout对象包含一个描述状态流的数据成员（继承于ios_base）被定义为iostate，是bitmask类型，由eofbit，badbit，failbit，每一位可以是1（设置）0（清除）</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1300168/201901/1300168-20190104215215497-1472804903.png" /></p>
<p><strong>clear：</strong>将状态设置为他的参数，默认0清楚全部状态；clear(eofbit)，eofbit被设置，其他清除</p>
<p><strong>setstate：</strong>setstate(eofbit)只设置eofbit，不影响其他位</p>
<p><strong>get()与getline()：</strong>get将换行符留在流中，getline抽取并丢弃输入流中的换行符</p>
<div>
<pre class="prettyprint linenums">char tem[];<br />
while(cin.get(tem,))//空行终止<br />
{<br />
    //...<br />
}

//空行不终止，因为空行不导致getline设置failbit，getline抽取换行符并丢弃<br />
while(cin.getline(tem,))<br />
{<br />
    //...<br />
}<br />
//空行终止<br />
while(cin.getline(tem,)&amp;&amp;tem[]!='\0')<br />
{<br />
    //...<br />
}</pre>
</div>
<p><strong>I/O异常</strong></p>
<p><strong>　　</strong>exceps()返回一个为字段，包含三位：eofbit，failbit，badbit。修改流状态后，clear()函数将当前流状态与exceps()的返回值比较，如果返回值中某一位被设置，当前流转态位对应位也被设置，则clear()引发ios_base::failure异常，exceptions()返回good不会引发异常，ios_base::failure从exception类派生，因此包含一个what()函数。</p>
<div>
<pre class="prettyprint linenums">#include &lt;iostream&gt;<br />
#include &lt;exception&gt;<br />
using namespace std;

int main()<br />
{<br />
    cin.exceptions(ios_base::failbit);

    int a=,sum=;<br />
    try<br />
    {<br />
        while(cin&gt;&gt;a)<br />
            sum+=a;<br />
    }<br />
    catch(ios_base::failure &amp;bf)<br />
    {<br />
        cout&lt;&lt;bf.what()&lt;&lt;endl;<br />
    }

    cout&lt;&lt;"last input:"&lt;&lt;a&lt;&lt;endl;<br />
    cout&lt;&lt;"sum:"&lt;&lt;sum&lt;&lt;endl;<br />
    return ;<br />
}</pre>
</div>
<div>
<pre class="prettyprint linenums">#include &lt;iostream&gt;<br />
#include &lt;exception&gt;<br />
#include &lt;fstream&gt;<br />
using namespace std;

//filebuf in;<br />
//istream i(&amp;in);<br />
int main()<br />
{<br />
    int a=,sum=;<br />
    while(cin&gt;&gt;a)//只有状态流良好(所有为都被清楚)的情况下，while或if才返回true<br />
        sum+=a;

    cout&lt;&lt;"last input:"&lt;&lt;a&lt;&lt;endl;<br />
    cout&lt;&lt;"sum:"&lt;&lt;sum&lt;&lt;endl;

    if(cin.fail()&amp;&amp;!cin.eof())<br />
    {<br />
        cin.clear();<br />
        while(!isspace(cin.get()))//get提供不跳过空白字符读的功能<br />
            continue;<br />
    }<br />
    else<br />
    {<br />
        cout&lt;&lt;" i cannot go on"&lt;&lt;endl;<br />
        exit();<br />
    }<br />
    cout&lt;&lt;"now input a new number:";<br />
    cin&gt;&gt;a;

    return ;<br />
}</pre>
</div>
<p><strong>cin.get(char &amp;)：</strong>到达文件末尾（真正的文件末尾，或键盘仿真文件末尾---win下ctrl+z---UNIX下ctrl+d，都不会给参数赋值，返回eof</p>
<p><strong>cin.get()：</strong>返回int类型的值，后不能跟抽取操作符，如：cin.get().get()&gt;&gt;c;</p>
<h3>基于文件</h3>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1300168/201901/1300168-20190104153627143-1310776802.jpg" /></p>
<p><strong>继承关系</strong></p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1300168/201901/1300168-20190104154409635-527796345.png" /></p>
<p><strong>程序写入文件</strong></p>
<ol><li>创建一个ofstream对象管理输出流</li>
<li>将对象与特定的文件关联</li>
<li>用cout的方式使用该对象</li>
<li>使用colse()显示关闭文件的链接；（对象过期时（程序中止））文件的链接会自动关闭
<div>
<pre class="prettyprint linenums">#include &lt;iostream&gt;<br />
#include &lt;fstream&gt;<br />
using namespace std;

int main()<br />
{<br />
    ofstream of;<br />
    of.open("1.txt");<br />
    //ofstream of("1.txt");//也可以用构造函数 

    of&lt;&lt;"ds";<br />
    of.close();//关闭文件将刷新缓冲区，确保文件被更新<br />
    return ;<br />}</pre>
</div></li></ol>
<p><strong>读取文件</strong></p>
<ol><li>创建一个ifstream对象管理输出流</li>
<li>将对象与特定的文件关联</li>
<li>用cin的方式使用该对象</li>
<li>使用colse()显示关闭文件的链接；（对象过期时（程序中止））文件的链接会自动关闭
<div>
<pre class="prettyprint linenums">#include &lt;iostream&gt;<br />
#include &lt;fstream&gt;<br />
using namespace std;

int main()<br />
{<br />
    ifstream fin;<br />
    fin.open("1.txt");<br />
    //ifstream fin("1.txt");//也可以用构造函数,可以用is_open()检查是否打开成功，若成功流状态为0

    string s;<br />
    fin&gt;&gt;s;<br />
    cout&lt;&lt;s&lt;&lt;endl;

    fin.close();//只是断开文件的链接，对象与他的缓冲区仍然存在<br />
    return ;<br />
}</pre>
</div></li></ol>
<p><strong><strong>当文件流作为类成员时，其初始化只能是初始化列表方式</strong>，即构造对象时文件，不能在构造函数体中进行操作，否则文件打开失败。</strong></p>
<p><strong>文本文件与二进制文件</strong></p>
<p>　　<strong>文本文件：</strong></p>
<p>　　　　所有内容都储存为文本，如：以文本格式存储123456，将存储6个字符，计算机内部将浮点数转为字符格式，这是&lt;&lt;插入操作符的工作；写文本文件时，linux，UNIX。dos c++自动将换行符转为回车和换行；读文本文件时，将本地的换行符转为c++格式；macintosh c++将换行转为回车。</p>
<p>　　<strong>二进制文件：</strong></p>
<p>　　　　计算机不存储字符，而存储64位double；字符的二进制和文本表示一样（字符的ASCII二进制表示）；较为精确，二进制保存数据更快，不需要转换，占用空间小，可大量存储；但二进制对于换行符，有歧义。二进制与文本文件的末未检测方式也不同。</p>
<p>　　二进制和文本模式的区别：<br />　　在windows系统中，文本模式下，文件以"\r\n"代表换行。若以文本模式打开文件，并用fputs等函数写入换行符"\n"时，函数会自动在"\n"前面加上"\r"。即实际写入文件的是"\r\n" 。<br />　　在类Unix/Linux系统中文本模式下，文件以"\n"代表换行。所以Linux系统中在文本模式和二进制模式下并无区别</p>
<div>
<pre class="prettyprint linenums">#include &lt;iostream&gt;<br />
#include &lt;fstream&gt;<br />
using namespace std;

struct Stu<br />
{<br />
    int age;<br />
    double weight;<br />
}stu;

int main()<br />
{<br />
    ofstream of;<br />
    of.open("1.txt"); 

    //到达stu的结构地址,并且将6个字节复制到与of相关的文件中，用write函数可以以二进制形式存储数据<br />
    of.write((char *)&amp;stu,sizeof(stu));<br />
    of.close();//关闭文件将刷新缓冲区，确保文件被更新 

    //将文件中的sizeof(stu)个字节复制到结构体中<br />
    ifstream fin("1.txt");<br />
    fin.read((char *)&amp;stu,sizeof(stu));<br />
    return ;<br />
}</pre>
</div>
<h3>基于字符串的I/O</h3>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1300168/201901/1300168-20190104153654374-1800442321.jpg" /></p>
<p><strong>继承关系</strong></p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1300168/201901/1300168-20190104154442127-2086977358.png" /></p>
<div>
<pre class="prettyprint linenums">#include &lt;iostream&gt;<br />
#include &lt;sstream&gt;<br />
using namespace std;

int main()<br />
{<br />
    ostringstream os;<br />
    string s("");<br />
    os&lt;&lt;s;<br />
      cout&lt;&lt;os.str()&lt;&lt;endl;

      ostringstream _os;<br />
      _os&lt;&lt;os.str();<br />
      cout&lt;&lt;_os.str()&lt;&lt;endl;//让_os从os中提取数据，str()成员函数的使用可以让istringstream对象返回一个string字符串

    return ;<br />
}</pre>
</div>
<p>清空stringstream对象中的内容</p>
<div>
<pre class="prettyprint linenums">    vector&lt;string&gt; s(v.size(),"");//确定字符串数组的大小<br />
    stringstream ss;<br />
    for(int i=;i&lt;v.size();++i)<br />
    {<br />
        ss&lt;&lt;v[i];<br />
        s[i]=ss.str();<br />
        ss.str("");    //清空stringstream对象中的内容，clear()只是清空了流的状态<br />
    }</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49gj6797.html">B样条基函数的定义和性质</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93y21n8.html">DirectX9 Sample&lowbar;Empty Project</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4zeee9.html">git上传文件出错的时候</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93gwg08.html">java 显示透明背景png图片</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq167p08.html">&lbrack;BZOJ 3530&rsqb;&lbrack;Sdoi 2014&rsqb;数数</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jw7pe8.html">括号匹配 区间DP （经典）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1omo28.html">Swift&mdash;final关键字-b</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zgvpk9.html">EF通用数据层封装类（支持读写分离，一主多从）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo346nq.html">打印水仙花数&lpar;narcissus number&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz72z08.html">aways on 配置部署（一）&mdash;&mdash;准备工作</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpemp69.html">Dashboard二次开发简明教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjon5k8.html">C&num;中USB转串口的拔插捕获</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjrdzj8.html">&lbrack;LeetCode&rsqb; Swap Adjacent in LR String 交换LR字符串中的相邻项</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4y03k9.html">&lbrack;CSS3&rsqb;环形进度条</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdv4dv9.html">百练6247-过滤多余的空格-2015正式B题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2g0g6q.html">C&num;爬取京东手机数据&plus;PowerBI数据可视化展示</a>
		</li>
						<li><a href="https://www.batexi.com/a/8em4lvx9.html">使用OkHttpClient处理json请求处理的方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwl2k2z9.html">Thymeleaf学习记录（3）--语法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r4zwge8.html">vSphere SDK for Java - 从模板部署虚拟机并配置IP地址</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e04xomq.html">redis的持久化方式</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qdjoee7q.html">python-day11--函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/qve0voo9.html">POJ-3087 Shuffle&amp;&num;39&semi;m Up （模拟）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rn0gyrq.html">JAVA 中CLOB与Clob有区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2k0j0xq.html">使用XML Publisher导出PDF报表</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdjopyxq.html">对称点line</a>
			</li>
						<li><a href="https://www.batexi.com/a/93pnwew8.html">标签传播算法（Label Propagation）及Python实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ko5o2rq.html">display&colon; table 实现menu等高居中排列</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jmpej49.html">javascript开发HTML5游戏--斗地主&lpar;单机模式part1&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o45d4lq.html">Python zipfile 编码问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwl0rnr9.html">Beta 冲刺（7&sol;7&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
